%global gem_name rr

%global rubyabi 1.9.1
  
%if 0%{?fedora} >= 17
  %global rubyabi 1.9.1
%endif

%if 0%{?fedora} >= 19
  %global rubyabi 2.0.0
%endif

Summary: RR (Double Ruby) is a test double framework 
Name: rubygem-%{gem_name}
Version: 1.0.4
Release: 9%{?dist}
Group: Development/Languages
License: MIT
URL: http://pivotallabs.com
Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem

%if 0%{?fedora} >= 19
Requires:       ruby(release)
%endif

%if 0%{?fedora} >= 17 && 0%{?fedora} < 19
Requires:      ruby(abi) = %{rubyabi}
%endif

%if 0%{?fedora} <= 17
Requires: ruby(rubygems) 
%endif

BuildRequires: ruby-irb
BuildRequires: rubygems-devel
BuildArch: noarch
Provides: rubygem(%{gem_name}) = %{version}

# The following are for running test suite
BuildRequires: rubygem(minitest)
BuildRequires: rubygem(session)
BuildRequires: rubygem(diff-lcs)

%description
RR (Double Ruby) is a test double framework that features a rich selection of
double techniques and a terse syntax.

A Test Double is a generalization of something that replaces a real object to
make it easier to test another object. Its like a stunt double for tests.

%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}

%prep
gem unpack %{SOURCE0}

%setup -q -D -T -n %{gem_name}-%{version}

# Modify the gemspec if necessary with a patch or sed
# Also apply patches to code if necessary
# %%patch0 -p1

gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec

%build
mkdir -p .%{gem_dir}

# Create the gem as gem install only works on a gem file
gem build %{gem_name}.gemspec

export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
# gem install compiles any C extensions and installs into a directory
# We set that to be a local directory so that we can move it into the
# buildroot in %%install
%if 0%{?fedora} >= 17 && 0%{?fedora} <= 18
gem install -V \
        --local \
        --install-dir ./%{gem_dir} \
        --bindir ./%{_bindir} \
        --force \
        --rdoc \
        --ri \
        %{gem_name}-%{version}.gem
%endif

%if 0%{?fedora} >= 19
%gem_install
%endif

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}/

# Remove leftovers.
rm  %{buildroot}%{gem_instdir}/.gitignore
rm  %{buildroot}%{gem_instdir}/.runrc
rm  %{buildroot}%{gem_instdir}/.rvmrc
rm  %{buildroot}%{gem_instdir}/Gemfile
rm  %{buildroot}%{gem_instdir}/Gemfile.lock
rm  %{buildroot}%{gem_instdir}/%{gem_name}.gemspec
rm  %{buildroot}%{gem_instdir}/doc/todo.txt
rm  %{buildroot}%{gem_dir}/cache/%{gem_name}-%{version}.gem
rm -rf  %{buildroot}%{gem_instdir}/.yardoc

# Fixing test-suite files to avoid bundler dependency
sed -i 's/require "bundler"/#require "bundler"/g' %{buildroot}%{gem_instdir}/spec/spec_suite.rb
sed -i 's/require "bundler"/#require "bundler"/g' %{buildroot}%{gem_instdir}/spec/environment_fixture_setup.rb

# Removing rspec dependency for testunit and minitest tests
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/environment_fixture_setup.rb
sed -i 's/require "spec\/autorun"/#require "spec\/autorun"/g' %{buildroot}%{gem_instdir}/spec/environment_fixture_setup.rb
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/rr/test_unit/test_unit_integration_test.rb
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/rr/test_unit/test_unit_backtrace_test.rb
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/rr/test_unit/test_unit_integration_test.rb

%check
# Run tests
pushd %{buildroot}%{gem_instdir}
# Run individual test suites until test suite is updated to rspec 2x
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb spec/rr/test_unit/test_unit_integration_test.rb
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb spec/rr/test_unit/test_unit_backtrace_test.rb
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb spec/rr/minitest/minitest_integration_test.rb
popd

# Remove leftovers.
rm  %{buildroot}%{gem_instdir}/Rakefile

%files
%dir %{gem_instdir}
%doc %{gem_instdir}/LICENSE
%{gem_libdir}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/doc
%doc %{gem_instdir}/introducting_rr.txt
%doc %{gem_instdir}/CHANGES
%doc %{gem_instdir}/README.rdoc
%{gem_instdir}/spec
%{gem_instdir}/benchmarks

%changelog
* Sun Mar 24 2013 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-7
- Removed unnecesary dependencies
- Fixes for Ruby 2.0.0 packaging

* Wed Feb 27 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.0.4-8
- F-19: Rebuild for ruby 2.0.0

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.4-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sun Jul 22 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-6
- Removed unnecesary dependencies
- Spec adjusted according new guidelines

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.4-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sun Feb 12 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-4
- Changelog entries fixed

* Tue Feb 07 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-3
- Updated spec file for Ruby 1.9 guidelines
- RSPec 1x tests disabled

* Tue Jan 24 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-2
- Removed unused macro from spec file
- Removed doc tag for benchmarks and spec file
- Removed cached version of the gem
- Fixed test suite files and test suite enabled at check section

* Sat Jan 21 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-1
- Initial package
